var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);

//var uri = kPersonalAddressbookURI;

//var directory = rdf.GetResource(uri).QueryInterface(Components.interfaces.nsIAbDirectory);



function AddSendertoAddressBook(event)

{

  var loadedFolder = GetLoadedMsgFolder();

  var messageArray = GetSelectedMessages();

  var senderAddress = null;

  var displayName;

  var primaryEmail;

  if (messageArray && messageArray.length > 0)

	{

		uri = "";

            for (var i = 0; i < messageArray.length; i ++)

		{

			var messageUri = messageArray[i];

			var hdr = messenger.messageServiceFromURI(messageUri).messageURIToMsgHdr(messageUri);

			senderAddress = hdr.author;

			unformattedAddress = senderAddress;

			formattedAddress = emailCleanup(unformattedAddress);

			primaryEmail = formattedAddress[0];

			displayName = formattedAddress[1];

			firstName = formattedAddress[2];

			lastName = formattedAddress[3];

			window.openDialog("chrome://addresscontext/content/aCNewCardDialog.xul", "", "chrome,titlebar,resizable=no", {primaryEmail:primaryEmail, displayName:displayName, firstName:firstName, lastName:lastName });

  		}

	}

}



function emailCleanup(unformattedAddress)

	{

		var primaryEmail;

		var displayName = null;

		if (unformattedAddress.search('<')!= -1)

			{

				var beginpos = unformattedAddress.search('<');

				var endpos = unformattedAddress.search('>');

				beginpos--;

				displayName = unformattedAddress.slice(0, beginpos);

				beginpos = beginpos + 2;

				primaryEmail = unformattedAddress.slice(beginpos, endpos);

			}

		if (/\"/.test(displayName))

			{

				leftofquote = displayName.indexOf("\"") + 1;

				rightofquote = displayName.lastIndexOf("\"");

				displayName = displayName.substring(leftofquote, rightofquote);

//				leftofbracket = unformattedAddress.indexOf("\<") + 1;

//				rightofbracket = unformattedAddress.lastIndexOf("\>");

//				primaryEmail = unformattedAddress.substring(leftofbracket,rightofbracket);

			}

		if (displayName)

			{

				lastName = /\w+$/.exec([displayName])

				firstName = displayName.replace(lastName, "")

				formattedAddress = new Array;

				formattedAddress[0] = primaryEmail;

				formattedAddress[1] = displayName;

				formattedAddress[2] = firstName;

				formattedAddress[3] = lastName;

			}

                if (!displayName)

			{

				primaryEmail = unformattedAddress;

				formattedAddress = new Array;

				formattedAddress[0] = primaryEmail;

				formattedAddress[1] = null;

				formattedAddress[2] = null;

				formattedAddress[3] = null;

			}

		return formattedAddress;

												

	}





 function AddRecipientstoAddressBook (event)

 {

	var loadedFolder = GetLoadedMsgFolder();

	var messageArray = GetSelectedMessages();

	var longRecipients = null;

	if (messageArray && messageArray.length > 0)

	{

		for (var i = 0; i < messageArray.length; i ++)

 		{

 			var messageUri = messageArray[i];

 			var hdr = messenger.messageServiceFromURI(messageUri).messageURIToMsgHdr(messageUri);

 			if (longRecipients == null)

 				{

 					longRecipients = hdr.recipients;

 				}

			else

 				{

               		longRecipients += ', ';

 					longRecipients += hdr.recipients;

 				}

 			if (hdr.ccList)

 				{

 					ccPeople = hdr.ccList;

	 				if (longRecipients == null)

 					{

 						longRecipients = hdr.ccList;

 					}



 					else

 						{

 						longRecipients += ', ';

 						longRecipients += ccPeople;

 						}

 				}

 		}

 		addressArray = new Array;

 		addressArray = createAddressList(longRecipients);

		window.openDialog("chrome://addresscontext/content/aCListDialog.xul",

		"",

 		"chrome,resizable=no,titlebar,modal,centerscreen", {addressArray:addressArray});

 	}

}



function createAddressList(longRecipients)

	{

		var done = 0;

		var arrayElement = 0;

		while (done == 0)

		{

			var commaDeclare = ",";

			if (longRecipients.search(commaDeclare) != -1)

			{

				oldRecipients = longRecipients;

				var blank = "";

				var commaPlace = longRecipients.indexOf("\,") + 2;

				var firstEntry = longRecipients.substr(0, commaPlace);

				currentName = firstEntry.replace(/\,\s/, "")

				// check for case of "Last Name, First Name" <email@address.com>

				if (/\"{1}/.test(currentName))

				{

					longRecipients = longRecipients.replace(firstEntry, blank);

					var commaPlace = longRecipients.indexOf("\,") + 2;

					var secondEntry = longRecipients.substr(0, commaPlace);

					longRecipients = longRecipients.replace(secondEntry, blank);

					firstName = currentName;

					secondName = secondEntry.replace(/\,\s/, "");

					currentName = firstName + " " + secondName;

					addressArray[arrayElement] = currentName;

				}

				else

				{

					addressArray[arrayElement] = currentName;

					longRecipients = longRecipients.replace(firstEntry, blank);

				}

			}

			else if (longRecipients.search(commaDeclare) == -1)

			{

				addressArray[arrayElement] = longRecipients;

				return addressArray;

				done++

			}

			arrayElement++;

		}

	}





function prepareMailWindow(){

	var selectedAB = null;

    selectedAB = kPersonalAddressbookURI;

//  gAddressBookBundle = document.getElementById("bundle_addressBook");

  // set popup with address book names

	var abPopup = document.getElementById('abPopup');

	if ( abPopup )

	{

		var menupopup = document.getElementById('abPopup-menupopup');

		if ( selectedAB && menupopup && menupopup.childNodes )

		{

			for ( var index = menupopup.childNodes.length - 1; index >= 0; index-- )

			{

				if ( menupopup.childNodes[index].getAttribute('value') == selectedAB )

				{

					abPopup.label = menupopup.childNodes[index].getAttribute('label');

					abPopup.value = menupopup.childNodes[index].getAttribute('value');

        			break;

        		}

      		}

    	}

	}

	document.getElementById('ListName').value = "New List";

	AppendNewRowAndSetFocus();

	awFitDummyRows(1);

	var total = window.arguments[0].addressArray.length;

	if (total)

	{

		var listbox = document.getElementById('addressingWidget');

		var newListBoxNode = listbox.cloneNode(false);

		var templateNode = listbox.getElementsByTagName("listitem")[0];

		top.MAX_RECIPIENTS = 0;

		for ( var i = 0;  i < total; i++ )

		{

			address = window.arguments[0].addressArray[i];

			SetInputValue(address, newListBoxNode, templateNode);

		}

			var parent = listbox.parentNode;

			parent.replaceChild(newListBoxNode, listbox);





	}

}

function newCardFromContext()
	{

		OnLoadNewCard();

		fillNames();

	}



function fillNames()

	{

		if ("firstName" in window.arguments[0])

		document.getElementById('FirstName').value = window.arguments[0].firstName;

		if ("lastName" in window.arguments[0] && "firstName" in window.arguments[0])

		document.getElementById('LastName').value = window.arguments[0].lastName;

	}

